/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.client.client.ui;

import java.util.List;

import org.dive4elements.river.client.shared.model.Data;
import org.dive4elements.river.client.shared.model.DataList;

import com.smartgwt.client.widgets.Canvas;

public class DistanceOnlyPartHistoricalPanel extends DistanceOnlyPartPanel {

    private static final long serialVersionUID = 1L;
    private List<String> validInputs;

    @Override
    protected void initHelperPanel(final DataList data) {
        final FromToTableHelperPanel helper = new FromToTableHelperPanel(data, "bedheights_for_part", this.MSG, null, null);
        final Canvas table = helper.getTable();
        this.validInputs = helper.getKeycolEntries();

        this.helperContainer.addMember(table);

    }

    @Override
    protected void initMinMaxValues(final DataList data) {
        try {
            for (final Data item : data.getAll()) {
                if (item.getLabel().equals("ld_from_part"))// misuse ld_from_part for max container
                    this.min = Double.valueOf(item.getItems()[0].getStringValue());

                if (item.getLabel().equals("ld_to_part"))// misuse ld_to_part for max container
                    this.max = Double.valueOf(item.getItems()[0].getStringValue());
            }
        }
        catch (final NumberFormatException nfe) {
            this.min = -Double.MAX_VALUE;
            this.max = Double.MAX_VALUE;
        }
    }

    @Override
    protected void initDefaultFrom(final DataList data) {
        final double from = (this.min < -99999.) ? 0 : this.min;
        this.distancePanel.setFrom(from);
    }

    @Override
    protected void initDefaultTo(final DataList data) {
        final double to = (this.max > 99999.) ? 0 : this.max;
        this.distancePanel.setTo(to);
    }
}
